---
title: Checkout and Build NSPR
slug: Mozilla/Developer_guide/Build_Instructions/Checkout_and-build_NSPR
tags:
  - Build documentation
  - Developing Mozilla
  - NSPR
  - Outdated_articles
---
<p>{{ Outdated("Please help by moving whatever helpful, up-to-date information there is on this page into <a href='\"en/NSPR_build_instructions\"'>NSPR build instructions</a> and turning this page into a redirect.") }}</p>

<h2 id="Checkout">Checkout</h2>

<p>To checkout NetScape Portable Runtime (NSPR) you need CVS 1.10 set the CVSROOT enviornment variable to:</p>

<pre>:pserver:anonymous@cvs-mirror.mozilla.org:/cvsroot</pre>

<p>Issue the command:</p>

<pre>cvs checkout [-r TAG] mozilla/nsprpub</pre>

<p>You now have NSPR checked out into the current working directory.</p>

<h2 id="Build">Build</h2>

<p>There are two different build procedures for NSPR, depending on which NSPR release you want to build. NSPR releases 4.1.x and earlier use the <em>classic</em> build method. Beginning with NSPR release 4.2 an <em>autoconf</em> based make system is used.</p>

<p>Building NSPR varies a little depending on platform. Building NSPR builds only NSPR libraries, the test cases must be built separately. Building debug and optimized targets requires options on the <code>gmake</code> or <code>configure</code> command line. Read on.</p>

<h3 id="Unix">Unix</h3>

<h4 id="Autoconf">Autoconf (NSPR 4.2 and later)</h4>

<p>In the directory you have checked NSPR out to, create a directory to contain the build targets; <code>cd</code> to that directory; run <code>configure</code> and <code>make</code>. For example, say:</p>

<pre>mkdir target
cd target
../mozilla/nsprpub/configure
gmake
cd pr/tests
gmake</pre>

<p>The above commands build the debug targets. To build the optimized targets, the <code>configure</code> command should say:</p>

<pre>... configure --enable-optimize --disable-debug</pre>

<p>For platforms supporting it, to build 64bit targets, add the <code>--enable-64bit</code> option to the <code>configure</code> command.</p>

<h4 id="Classic">Classic (NSPR 4.1.x and earlier)</h4>

<p>Building debug targets, first NSPR itself, then the test suite:</p>

<pre>cd mozilla/nsprpub
gmake
cd pr/tests
gmake
</pre>

<p>To build the optimized targets, change the <code>gmake</code> commands to:</p>

<pre>gmake BUILD_OPT=1</pre>

<h3 id="Windows">Windows</h3>

<h4 id="Autoconf_2">Autoconf (NSPR 4.2 and later)</h4>

<p>Using the autoconf build method on Windows requires <a class="external" href="http://cygwin.com/">the Cygwin Toolkit</a>.</p>

<p>Open a Cygwin window. Follow the procedure described for building NSPR on Unix.</p>

<h4 id="Classic_2">Classic (NSPR 4.1.x and earlier)</h4>

<p>Building Windows targets is similar. There are two builds for Windows: a generic Win32 build and a WinNT build. The difference is that the WinNT build runs only on Windows NT (and Windows 2000); the generic Win32 build runs on any of Win9x, WinME, WinNT, Win2K.</p>

<p>The following assumes MSVC 6.0 with ServicePack 4. The compiler is must be configured to run from the command line.</p>

<p>To build the generic Win32 debug targets:</p>

<pre>cd mozilla\nsprpub
gmake OS_TARGET=WIN95
cd pr\tests
gmake OS_TARGET=WIN95</pre>

<p>To build the optimized targets, add <code>BUILD_OPT=1</code> option to the <code>gmake</code> command.</p>

<p>To build the WinNT debug targets:</p>

<pre>cd mozilla\nsprpub
gmake
cd pr\tests
gmake</pre>

<p>To build the optimized targets, add <code>BUILD_OPT=1</code> option to the <code>gmake</code> command.</p>

<h3 id="Mac">Mac</h3>

<p>Follow the Unix build instructions.</p>

<h3 id="Others">Others</h3>

<p>Specialists on mozilla contributed ports are invited to contribute to this section.</p>

<h2 id="Original_Document_Information">Original Document Information</h2>

<div class="originaldocinfo">
<ul>
 <li>Authors: <a class="link-mailto" href="mailto:larryh@netscape.com">larryh@netscape.com</a>, Wan Teh Chang</li>
 <li>Last Updated Date: November 7, 2001</li>
</ul>
</div>
